#define _LARGEFILE_SOURCE
#define _LARGEFILE64_SOURCE
#define _FILE_OFFSET_BITS 64
#include <R.h>
#define my_log_sqrt_2pi 0.918938533204672741780329736406	/* log(sqrt(2*pi)) */
void comp_pred(int *k, int *m, int *n_star, double *y_star, char **dir_label, char **dir_w, 
							 char **dir_mu, char **dir_sigma2, char **dir_pred){
  int i, j, h, *label;
  double *w, *mu, *sigma2, aa, *bb, *cc, **pred;  
  FILE *ffile_label, *ffile_w, *ffile_mu, *ffile_sigma2, *ffile_pred;
  /* To read the results of the raw Gibbs */
  ffile_label = fopen(*dir_label, "r" );
  ffile_w = fopen(*dir_w, "r" );
  ffile_mu = fopen(*dir_mu, "r" );
  ffile_sigma2 = fopen(*dir_sigma2, "r" );
  /*  Classification  */
  ffile_pred = fopen(*dir_pred, "w");
	
  label = Calloc(*k, int);
  w = Calloc(*k, double);
  mu = Calloc(*k, double);
  sigma2 = Calloc(*k, double);
  bb = Calloc(*k, double);
  cc = Calloc(*k, double);
  pred = Calloc(*n_star, double *);
  for(i = 0; i < *n_star; i++){
    pred[i] = Calloc(*k, double);
  }
  /* Results to Analysis */
  for(h = 0; h < *m; h++){
    /* Reading results of the Gibbs sampler */
    for(j = 0; j< *k; j++){
			if(fscanf(ffile_label, "%d ", &label[j]) != 1){
				Rprintf("Problem reading the labels");
				exit(1);
      }
      if(fscanf(ffile_w, "%lf ", &w[j]) != 1){
				Rprintf("Problem reading the weights");
				exit(1);
      }
      if(fscanf(ffile_mu, "%lf ", &mu[j]) != 1){
				Rprintf("Problem reading the means");
				exit(1);
      }
      if(fscanf(ffile_sigma2, "%lf ", &sigma2[j]) != 1){
				Rprintf("Problem reading sigma2");
				exit(1);
      }
      bb[j] = 0.0;
      cc[j] = 0.0;
      bb[j] += 2.0*sigma2[j];
      cc[j] += log(w[j]);
			cc[j] -= my_log_sqrt_2pi + 0.5*log(sigma2[j]);      
    }
    for(i = 0; i < *n_star; i++){      
      for(j = 0; j < *k; j++){
				aa = 0.0;	 
				aa -= (y_star[i] - mu[label[j]])*(y_star[i] - mu[label[j]]);
				aa /= bb[label[j]];
				aa += cc[label[j]];
				pred[i][j] += exp(aa);
      }
    }
  }
  for(i = 0; i < *n_star; i++){
    for(j = 0; j < *k; j++){
			fprintf(ffile_pred, "%12.16f \t", pred[i][j]/((double) *m));
    }
    fprintf(ffile_pred, "\n");
  }  
  /* Freeing variables */
  Free(label);
  Free(w);
  Free(mu);
  Free(sigma2);
  Free(bb);
  Free(cc);
  for(i = 0; i < *n_star; i++){
    Free(pred[i]);
  }
  Free(pred);
  /* Closing files */
  fclose(ffile_label);
  fclose(ffile_w);
  fclose(ffile_mu);
  fclose(ffile_sigma2);
  fclose(ffile_pred);
}