#define _LARGEFILE_SOURCE
#define _LARGEFILE64_SOURCE
#define _FILE_OFFSET_BITS 64
#include <R.h>
void compar_posterior_mean(int *k, int *m, double *w, double *mu, double *sigma2, char **dir_one_label, 
										char **dir_two_label, char **dir_three_label, char **dir_w, char **dir_mu, 
										char **dir_sigma2){  
	int j, h, twok = 2*(*k), ip, iz, label_one[*k], label_two[*k], label_three[*k];
	double w_tmp[*k], mu_tmp[*k], sigma2_tmp[*k];
	FILE *ffile_one_label, *ffile_two_label, *ffile_three_label, *ffile_w, *ffile_mu, *ffile_sigma2;
	
	ffile_one_label = fopen(*dir_one_label, "r" );
	ffile_two_label = fopen(*dir_two_label, "r" );
	ffile_three_label = fopen(*dir_three_label, "r" );	
  ffile_w = fopen(*dir_w, "r" );
	ffile_mu = fopen(*dir_mu, "r" ); 
	ffile_sigma2 = fopen(*dir_sigma2, "r" ); 
  
  for(h = 0; h < *m; h++){		
		for(j = 0; j < *k; j++){
			if(fscanf(ffile_one_label, "%d ", &label_one[j]) != 1){
				Rprintf("Problem reading the labels");
				exit(1);
			}
			if(fscanf(ffile_two_label, "%d ", &label_two[j]) != 1){
				Rprintf("Problem reading the labels");
				exit(1);
			}
			if(fscanf(ffile_three_label, "%d ", &label_three[j]) != 1){
				Rprintf("Problem reading the labels");
				exit(1);
			}			
			if(fscanf(ffile_w, "%lf ", &w_tmp[j]) != 1){
				Rprintf("Problem reading the weights");
				exit(1);
			}
			if(fscanf(ffile_mu, "%lf ", &mu_tmp[j]) != 1){
				Rprintf("Problem reading the means");
				exit(1);
			}
			if(fscanf(ffile_sigma2, "%lf ", &sigma2_tmp[j]) != 1){
				Rprintf("Problem reading sigma2");
				exit(1);
			}
		}
		for(j = 0; j < *k; j++){
			w[j] += w_tmp[label_one[j]];
			mu[j] += mu_tmp[label_one[j]];
			sigma2[j] += sigma2_tmp[label_one[j]];	
			ip = *k + j;
			w[ip] += w_tmp[label_two[j]];
			mu[ip] += mu_tmp[label_two[j]];
			sigma2[ip] += sigma2_tmp[label_two[j]];
			iz = twok + j; 
			w[iz] += w_tmp[label_three[j]];
			mu[iz] += mu_tmp[label_three[j]];
			sigma2[iz] += sigma2_tmp[label_three[j]];			
		}			
  }
  for(j = 0; j < *k; j++){
		w[j] /= (double) *m;
		mu[j] /= (double) *m;
		sigma2[j] /= (double) *m;
		ip = *k + j;
		w[ip] /= (double) *m;
		mu[ip] /= (double) *m;
		sigma2[ip] /= (double) *m;
		iz = twok + j; 
		w[iz] /= (double) *m;
		mu[iz] /= (double) *m;
		sigma2[iz] /= (double) *m;		
	}		
  /* Closing files */
	fclose(ffile_one_label);
	fclose(ffile_two_label);
	fclose(ffile_three_label);
	fclose(ffile_w);
	fclose(ffile_mu);
	fclose(ffile_sigma2);	
}