#include <R.h>
#include <Rmath.h>
#include <math.h>
/* Generating a random variable from Gamma(alpha, beta) */
double rmygamma(double alpha, double beta);
/*   Extract randomly one element of {0, 2, ..., k-1} with   */
/*   probabilities p the probabilities in p does not sum up  */
/*   to one but divided by scale_p they do sum 1 (burn)      */
int sample_probs_burn(int k, int *perm, double *p, double scale_p);
/*   Extract randomly one element of {0, 2, ..., k-1} with   */
/*   probabilities p the probabilities in p does not sum up  */
/*   to one but divided by scale_p they do sum 1 (store)      */
int sample_probs(int k, int *perm, double *p);
/* Updating allocations for the Gibbs sampler (burn) */
void sample_allocations_burn(int k, int n, int *z, double *y, double *w, double *mu,
			     double *tau, double *sqrt_tau, int *nj, double *y_sum,
			     double *y2_sum);
/* Updating allocations for the Gibbs sampler */
void sample_allocations(int k, int n, int *z, double *y, double *w, double *mu,
			double *tau, double *sqrt_tau, int *nj, double *y_sum,
			double *y2_sum, FILE *ffile_z, FILE *ffile_pz);