#define _LARGEFILE_SOURCE
#define _LARGEFILE64_SOURCE
#define _FILE_OFFSET_BITS 64
#include <R.h>
#include "LSAP.h"

void ECR_relabel(int *k, int *n, int *m, int *z_map, char **dir_z, char **dir_label){
  
  int j, l, i, h, *aj, **bjl, z[*n], label[*k];
  double **C;
  FILE *ffile_z, *ffile_label;

  ffile_z = fopen(*dir_z, "r" );  
  ffile_label = fopen(*dir_label, "w" );  

  aj = Calloc(*k, int);
  bjl = Calloc(*k, int *);
  C = Calloc(*k, double *);  
  for(j = 0; j < *k; j++){
    bjl[j] = Calloc(*k, int);
    C[j] = Calloc(*k, double);    
  }
    
  /*-----------------------------------------------------------------*/
  /* Easy Loop: reading allocations and undoing the label switching  */
  /*-----------------------------------------------------------------*/
  for(h = 0; h < *m; h++){
    
    for(i = 0; i < *n; i++){
      if(fscanf(ffile_z, "%d ", &z[i]) != 1 ){
	Rprintf("Problem reading allocations\n");
	exit(1);
      }
      aj[z[i]]++;
      bjl[z[i]][z_map[i]]++;
    }
    
    for(j = 0; j < *k; j++){
      for(l = 0; l < *k; l++){
	C[l][j] = aj[j] - bjl[j][l];
	bjl[j][l] = 0;
      }      
      aj[j] = 0;
    }
      
    /* Solving the assignment problem via the Hungarian method: from R (library clue)*/
    solve_LSAP(C, *k, label);

    /* Storing the new labels */
    for(j =0; j < *k; j++){
      fprintf(ffile_label, "%d \t", label[j]);
    }
    fprintf(ffile_label, "\n");

  }
  Free(aj);
  for(j = 0; j < *k; j++){
    Free(bjl[j]);
    Free(C[j]);    
  }
  Free(bjl);
  Free(C);  
  fclose(ffile_label);
  fclose(ffile_z);
}