#define _LARGEFILE_SOURCE
#define _LARGEFILE64_SOURCE
#define _FILE_OFFSET_BITS 64
#include <R.h>
#include "LSAP.h"

void group_mean_var(int *k, int *n, int *m, double *y, double *mu, double *sigma2, char **dir_z){  
  int j, l, i, h, nj[*k], label[*k], z, n_mu[*k], n_sig[*k];
	double **C, ysum[*k], y2sum[*k], ybar[*k], s2[*k];
	FILE *ffile_z;

  ffile_z = fopen(*dir_z, "r" );  
  
	C = Calloc(*k, double *);  
  for(j = 0; j < *k; j++){
    C[j] = Calloc(*k, double);
		ysum[j] = 0.0;
		y2sum[j] = 0.0;
		nj[j] = 0;	
		n_mu[j] = 1;
		n_sig[j] = 1;
  }   

  /*-----------------------------------------------------------------*/
  /* Easy Loop: reading allocations and undoing the label switching  */
  /*-----------------------------------------------------------------*/
  for(h = 0; h < *m; h++){		
    for(i = 0; i < *n; i++){
      if(fscanf(ffile_z, "%d ", &z) != 1 ){
				Rprintf("Problem reading allocations\n");
				exit(1);
      }
      ysum[z] += y[i];
      y2sum[z] += y[i]*y[i];
			nj[z]++;
    }    
    for(j = 0; j < *k; j++){
			for(l = 0; l < *k; l++){
				C[l][j] = y2sum[j] - 2.0*ysum[j]*mu[l] + ((double) nj[j])*mu[l]*mu[l];	
				C[l][j] /= sigma2[l];
				C[l][j] *= (double) nj[j];
			}
		}      
		/* Solving the assignment problem via the Hungarian method: from R (library clue)*/
		solve_LSAP(C, *k, label);
		/* Averaging the new labels */
		for(j = 0; j < *k; j++){	
			if(nj[label[j]] > 1){
				ybar[j] = ysum[label[j]]/((double) nj[label[j]]);
				mu[j] *= (double) (n_mu[j]-1);
				mu[j] += ybar[j];
				mu[j] /= (double) n_mu[j];					
				s2[j] = y2sum[label[j]] - ((double) nj[label[j]])*ybar[j]*ybar[j];
				s2[j] /= (double) (nj[label[j]] - 1);				
				sigma2[j] *= (double) (n_sig[j]-1);
				sigma2[j] += s2[j];
				sigma2[j] /= (double) n_sig[j];	
				n_mu[j]++;
				n_sig[j]++;
			}else{
				if(nj[label[j]] == 1){
					ybar[j] = ysum[label[j]];
					mu[j] *= (double) (n_mu[j]-1);
					mu[j] += ybar[j];
					mu[j] /= (double) n_mu[j];
					n_mu[j]++;
				}
			}
			ysum[label[j]] = 0.0;
			y2sum[label[j]] = 0.0;
			nj[label[j]] = 0;			
		}
  }
  for(j = 0; j < *k; j++){
    Free(C[j]);    
  }
  Free(C);  
  fclose(ffile_z);
}